'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var react = require('react');

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
    return;
  }

  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function useLocalStorage(key, initialValue) {
  var _useState = react.useState(initialValue),
      _useState2 = _slicedToArray(_useState, 1),
      storeIniitalValue = _useState2[0];

  var _useState3 = react.useState(function () {
    try {
      var item = window.localStorage.getItem(key);
      return item !== null ? JSON.parse(item) : initialValue;
    } catch (e) {
      return initialValue;
    }
  }),
      _useState4 = _slicedToArray(_useState3, 2),
      localStorage = _useState4[0],
      setValue = _useState4[1];

  var setLocalStorage = function setLocalStorage(value) {
    try {
      var valueToStore = value instanceof Function ? value(localStorage) : value;
      valueToStore === null ? setValue(storeIniitalValue) : setValue(valueToStore);
      valueToStore === null ? window.localStorage.removeItem(key) : window.localStorage.setItem(key, JSON.stringify(valueToStore));
    } catch (e) {
      console.log(e);
    }
  };

  return [localStorage, setLocalStorage];
}

exports.useLocalStorage = useLocalStorage;
//# sourceMappingURL=index.js.map
